/////////////////////////////////////////////////
//Revolution Engine.
//by Technik
/////////////////////////////////////////////////

//External header files
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include <math.h>
#include <wiiuse/wpad.h>
#include <fat.h>
#include <pngu.h>
#include <time.h>
#include <ogc/lwp_watchdog.h>
//Internal header files
#include "REVObject.h"
#include "REVTypes.h"

//Definitions
#define Phantom 0//physical modes

#define OBJ_DEF_CLR ((GXColor){255,255,255,255})

//Golbal data
extern ROOT * mainRoot;

//Function prototypes
void addObj(OBJECT * obj);

//Public functions
OBJECT * newObj(MODEL * model, MATERIAL * material, BODY * body, Vector pos, Vector ang, u8 flags)
{
	Mtx Aux;
	OBJECT * nObj = (OBJECT*)malloc(sizeof(OBJECT));
	nObj->model = model;
	nObj->body = body;
	nObj->material = material;
	nObj->state.pos = pos;
	nObj->state.spd = nullVector;
	nObj->state.asp = nullVector;
	nObj->state.mode = Phantom;
	nObj->state.type = NT_OBJECT;
	nObj->clr = OBJ_DEF_CLR;
	nObj->flags = flags;
	//now we init the physical state
	guMtxIdentity(nObj->state.modMtx);
	guMtxRotDeg(Aux, 'y', ang.y);
	guMtxConcat(Aux, nObj->state.modMtx, nObj->state.modMtx);
	guMtxRotDeg(Aux, 'x', ang.x);
	guMtxConcat(Aux, nObj->state.modMtx, nObj->state.modMtx);
	guMtxRotDeg(Aux, 'z', ang.z);
	guMtxConcat(Aux, nObj->state.modMtx, nObj->state.modMtx);
	guMtxTransApply(nObj->state.modMtx, nObj->state.modMtx, pos.x, pos.y, pos.z);
	//we add the object to root
	addObj(nObj);
	return nObj;
}

//Internal functions
void addObj(OBJECT * obj)
{
	obj->next = mainRoot->fstObj;
	mainRoot->fstObj = obj;
	newChild(mainRoot->rootNode, (NODE*)obj);
}
